Robotsystem from Robot Group Leipzig: HurlingSnake Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Alphabetical List
- Class Hierarchy
- Class Members

# HurlingSnake Class Reference

`#include <hurlingsnake.h>`

Inheritance diagram for HurlingSnake:

[legend]
Collaboration diagram for HurlingSnake:

[legend]
List of all members.

## Detailed Description

Hurling snake is a string a beats.

Definition at line 84 of file hurlingsnake.h.

## Public Member Functions
| HurlingSnake (const OdeHandle &odeHandle, const OsgHandle &osgHandle)
| Constructor.
virtual void | update ()
| update the subcomponents
virtual void | place (const osg::Matrix &pose)
| sets the pose of the vehicle
virtual bool | collisionCallback (void *data, dGeomID o1, dGeomID o2)
| checks for internal collisions and treats them.
virtual void | doInternalStuff (const GlobalData &globalData)
| this function is called in each timestep.
virtual int | getSensors (sensor *sensors, int sensornumber)
| returns actual sensorvalues
virtual void | setMotors (const motor *motors, int motornumber)
| sets actual motorcommands
virtual int | getSensorNumber ()
| returns number of sensors
virtual int | getMotorNumber ()
| returns number of motors
virtual int | getSegmentsPosition (vector< Position > &poslist)
| returns a vector with the positions of all segments of the robot
virtual paramkey | getName () const
| returns the name of the object (with version number)
virtual paramlist | getParamList () const
| The list of all parameters with there value as allocated lists.
virtual paramval | getParam (const paramkey &key) const
virtual bool | setParam (const paramkey &key, paramval val)
## Protected Member Functions
virtual Primitive * | getMainPrimitive () const
| the main object of the robot, which is used for position and speed tracking

## Constructor & Destructor Documentation

HurlingSnake | ( | const OdeHandle & | odeHandle,
|  | const OsgHandle & | osgHandle
| ) |

  | Constructor. Parameters:
  | w | world in which robot should be created
  | s | space in which robot should be created
  | c | contactgroup for collision treatment
Definition at line 78 of file hurlingsnake.cpp.

## Member Function Documentation

bool collisionCallback | ( | void * | data,
|  | dGeomID | o1,
|  | dGeomID | o2
| ) | `[virtual]`

| checks for internal collisions and treats them. In case of a treatment return true (collision will be ignored by other objects and the default routine) else false (collision is passed to other objects and (if not treated) to the default routine). Implements OdeRobot. Definition at line 150 of file hurlingsnake.cpp.

void doInternalStuff | ( | const GlobalData & | globalData | ) | `[virtual]`

  | this function is called in each timestep. It should perform robot-internal checks, like space-internal collision detection, sensor resets/update etc. Parameters:
  | globalData | structure that contains global data from the simulation environment
Implements OdeRobot. Definition at line 123 of file hurlingsnake.cpp.

virtual Primitive* getMainPrimitive | ( |  | ) | const`[inline, protected, virtual]`

| the main object of the robot, which is used for position and speed tracking Implements OdeRobot. Definition at line 151 of file hurlingsnake.h.

int getMotorNumber | ( |  | ) | `[virtual]`

| returns number of motors Implements AbstractRobot. Definition at line 217 of file hurlingsnake.cpp.

virtual paramkey getName | ( |  | ) | const`[inline, virtual]`

| returns the name of the object (with version number) Reimplemented from Configurable. Definition at line 139 of file hurlingsnake.h.

Configurable::paramval getParam | ( | const paramkey & | key | ) | const`[virtual]`

| Definition at line 295 of file hurlingsnake.cpp.

Configurable::paramlist getParamList | ( |  | ) | const`[virtual]`

| The list of all parameters with there value as allocated lists. Reimplemented from Configurable. Definition at line 285 of file hurlingsnake.cpp.

int getSegmentsPosition | ( | vector< Position > & | poslist | ) | `[virtual]`

  | returns a vector with the positions of all segments of the robot Parameters:
  | poslist | vector of positions (of all robot segments)
Returns: length of the list Definition at line 226 of file hurlingsnake.cpp.

int getSensorNumber | ( |  | ) | `[virtual]`

| returns number of sensors Implements AbstractRobot. Definition at line 211 of file hurlingsnake.cpp.

int getSensors | ( | sensor * | sensors,
|  | int | sensornumber
| ) | `[virtual]`

  | returns actual sensorvalues Parameters:
  | sensors | sensors scaled to [-1,1]
  | sensornumber | length of the sensor array
Returns: number of actually written sensors Implements AbstractRobot. Definition at line 186 of file hurlingsnake.cpp.

void place | ( | const osg::Matrix & | pose | ) | `[virtual]`

  | sets the pose of the vehicle Parameters:
  | pose | desired 4x4 pose matrix
Implements OdeRobot. Definition at line 116 of file hurlingsnake.cpp.

void setMotors | ( | const motor * | motors,
|  | int | motornumber
| ) | `[virtual]`

  | sets actual motorcommands Parameters:
  | motors | motors scaled to [-1,1]
  | motornumber | length of the motor array
Implements AbstractRobot. Definition at line 203 of file hurlingsnake.cpp.

bool setParam | ( | const paramkey & | key,
|  | paramval | val
| ) | `[virtual]`

| Definition at line 303 of file hurlingsnake.cpp.

void update | ( |  | ) | `[virtual]`

| update the subcomponents Implements OdeRobot. Definition at line 105 of file hurlingsnake.cpp.